package robo;

import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

/**
 * 
 * @author Ngo Van Luyen - IFI
 * 
 * 1. GetData
 * 2. MakeRecord
 * 3. WriteNodeBin
 * 
 */

public class MakeNodeBin {
	int Nnumber = 0; // total of node! How many node that I have?
	Node node = null;
	ArrayList<Node> nodeList = null;
	
	public MakeNodeBin(){
		
	}
	public MakeNodeBin(ArrayList<Node> nodel){
		if (nodeList != null) nodeList.clear();
		nodeList = nodel;
		Nnumber = nodeList.size();
	}
	/**
	 * Wite data into node.bin
	 * 
	 * @param path :
	 *            Path to node.bin, ex: bin/node.bin
	 */
	public void WriteNodeBin(String path) {
		try {
			// DataOutputStream nodebin = new DataOutputStream(new
			// FileOutputStream("bin/node.bin"));
			//DataOutputStream nodebin = new DataOutputStream(new FileOutputStream(path));
			DataOutputStream nodebin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
			tools.General.writeInt(nodebin, 0);// offset data
			tools.General.writeInt(nodebin, 0);
			tools.General.writeInt(nodebin, 0);// end offset
			tools.General.writeInt(nodebin, Nnumber);// number of node
			System.out.println("Total node: " + Nnumber);
			for (int j = 0; j < Nnumber; j++) {
				node = (Node) nodeList.get(j);

				tools.General.writeInt(nodebin, node.record);
				tools.General.writeInt(nodebin, node.getID());
				tools.General.writeInt(nodebin, node.getX());
				tools.General.writeInt(nodebin, node.getY());
				tools.General.writeInt(nodebin, node.getCN());
				for (int j2 = 0; j2 < node.getCN(); j2++) {
					tools.General.writeInt(nodebin, node.getCR(j2));
				}
				tools.General.writeInt(nodebin, 0); //signal
				for(int j2 = 0; j2 < node.getCN(); j2++)
					tools.General.writeInt(nodebin, 0); //shortcut
				for(int j2 = 0; j2 < node.getCN(); j2++){
					tools.General.writeInt(nodebin, 0); //pocket
					tools.General.writeInt(nodebin, 0);
				}
				for(int j2 = 0; j2 < node.getCN(); j2++){
					tools.General.writeInt(nodebin, 0); //signal timing
					tools.General.writeInt(nodebin, 0);
					tools.General.writeInt(nodebin, 0);
				}
			}
			nodebin.flush();
			nodebin.close();
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}

	/**
	 * 
	 * @return ArrayList<Node>
	 */
	public ArrayList<Node> getNodeList(){
		return nodeList;
	}
	
	public void setNodeList(ArrayList<Node> nodel){
		nodeList = nodel;
		Nnumber = nodeList.size();
	}
	
	/**
	 * Get a list of edge IDs for a node.
	 * @param bIds The IDs assigned to each building.
	 * @param rIds The IDs assigned to each road.
	 * @param n The node to find the edges of.
	 * @return A list of the IDs of all adjacent objects.
	 **/
	/*public int[] edges(int[] bIds, int[] rIds, int[][] rs,int n){
		ArrayList es = new ArrayList(10);
		for(int i = 0; i < buildingCount; i++)
			if(buildingEntrances[i] == n)
				es.add(new Integer(bIds[i]));
		for(int i = 0; i < rs.length; i++)
			if(rs[i][0] == n || rs[i][1] == n)
				es.add(new Integer(rIds[i]));
		int[] edges = new int[es.size()];
		for(int i = 0; i < edges.length; i++)
			edges[i] = ((Integer)es.get(i)).intValue();
		return edges;
	}*/
	public void MakeRecord(ArrayList<Road> roadList, int Rnumber) {
		Road road = null;

		for (int j = 0; j < Nnumber; j++) {
			for (int j2 = 0; j2 < Rnumber; j2++) {
				node = (Node) nodeList.get(j);
				road = (Road) roadList.get(j2);
				if (node.getID() == road.getHID()) {
					node.put((int) road.getID());
				}
				if (node.getID() == road.getTID()) {
					node.put((int) road.getID());
				}
			}
			node.record = 6 + (7 * node.getCN());
		}
	}
	
	public void makeEmptyNodeBin(String path) {
		try {
			//DataOutputStream nodebin = new DataOutputStream(new FileOutputStream(path));
			DataOutputStream nodebin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
			tools.General.writeInt(nodebin, 0);// offset data
			tools.General.writeInt(nodebin, 0);
			tools.General.writeInt(nodebin, 0);// end offset
			tools.General.writeInt(nodebin, 0);// number of node; total of node
			tools.General.writeInt(nodebin, 0);
			nodebin.flush();
			nodebin.close();
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
}
